#include<bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    long long n, q;
    cin >> n >> q;
    vector<long long> d(n), p(n);
    vector<long long> h(q);
    for(int i=0;i<n;i++) {
        cin >> d[i] >> p[i];
    }
    for(int i=0;i<q;i++) {
        cin >> h[i];
    }
    for(int i=0; i<n; i++) {
        long long z=0;
        int br=0;

        for(int j=0; j<q; j++) {
                if(p[j] == 0) {
            h[i] -= d[j];
        br++;
        if(h[i]==0) {
                cout << br << endl;
                j=q;
        }
        else if(h[i]<0) {
            cout << "-1" << endl;
            j=q;
        }
                }


    } }
    return 0;
}